<?php
/*
Plugin Name: Watcheezy Wordpress Plugin
Plugin URI: http://www.watcheezy.com
Description: A plugin that eases the integration of the <a href="http://www.watcheezy.com">Watcheezy</a> live chat application. Please finish the installation/reactivation process by clicking on Watcheezy in left menu .
Version: 1.5
Author: Watcheezy
Author URI: http://www.watcheezy.com

=== VERSION HISTORY ===

*/

$wee_domain = 'watcheEasyWPPlugin';

// Runs on plugin deactivation
register_deactivation_hook( __FILE__, 'watcheezy_remove' );

if($_POST['weeEmail'])
{
	update_option('weeFN', $_POST['weeFN']);
	update_option('weeLN', $_POST['weeLN']);
	update_option('weeEmail', $_POST['weeEmail']);
	update_option('weePwd', $_POST['weePwd']);
	
	if(!get_option('weeID'))
	{
		//Generate key and activate Watcheezy
		//update_option('weeID', md5(rand().rand()));
		$res = getRemote('https://www.watcheezy.net/public/get_remote_licence.php?cms=WP&key='.get_option('weeID').'&url='.$_POST['weeUrl'].'&firstname='.get_option('weeFN').'&lastname='.get_option('weeLN').'&password='.get_option('weePwd').'&email='.get_option('weeEmail'));
		
		if(strlen($res) <= 5 )
		{
			update_option('weeError', $res); 
		}
		else
		{
			update_option('weeError', '');
			update_option('weeID', $res);
		}
	}
}

add_action('wp_footer', 'wee_insert');
function wee_insert()
{
	if(get_option('weeID'))
	{
		echo "<!-- WATCHEEZY -->\n<script type=\"text/javascript\" src=\"//www.watcheezy.net/deliver/watcheezy.js?key=".get_option('weeID')."&install=footer\"></script>\n<!-- END WATCHEEZY -->";
	}
}

add_action('admin_notices', 'wee_admin_notice');
function wee_admin_notice()
{
	if(!get_option('weeEmail')) 
		echo('<div class="error"><p><strong>'.sprintf(__('Watcheezy plugin is disabled. Please go to the <a href="%s">plugin page</a> and complete form to enable it.' ), admin_url('options-general.php?page=watcheezy-wordpress-plugin')).'</strong></p></div>');
}

//add_filter('plugin_action_links', 'wee_plugin_actions', 10, 2);
function we_plugin_actions($links, $file)
{
	static $this_plugin;
	if(!$this_plugin) $this_plugin = plugin_basename(__FILE__);
	if($file == $this_plugin && function_exists('admin_url'))
	{
		$settings_link = '<a href="'.admin_url('options-general.php?page=watcheezy-wordpress-plugin').'">'.__('Settings', $wee_domain).'</a>';
		array_unshift($links, $settings_link);
	}
	return($links);
}

function getRemote($url, $port = 80)
{
	if (function_exists("curl_init"))
	{
		$curl_handle = curl_init();
		curl_setopt($curl_handle, CURLOPT_URL, $url);
		curl_setopt($curl_handle, CURLOPT_PORT, $port);
		curl_setopt($curl_handle, CURLOPT_HEADER, FALSE);
		curl_setopt($curl_handle, CURLOPT_COOKIESESSION, TRUE);
		curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, TRUE);
		curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($curl_handle, CURLOPT_SSL_VERIFYHOST, 2);
		curl_setopt($curl_handle, CURLOPT_POST, FALSE);
		$data = curl_exec($curl_handle);
		curl_close($curl_handle);
		
		if(!$data OR empty($data))
			$data = file_get_contents($url);
	}
	else
	{
		$data = file_get_contents($url);
	}

	return $data;
}

function watcheezy_admin_menu_styles()
{
	//global $watcheezy;
	wp_enqueue_style('watcheezy_admin_menu_styles', plugins_url() . '/watcheezy-wordpress-plugin/assets/css/menuw.css' );
}

function watcheezy_remove()
{
	// Deletes the database field
	delete_option('weeId');
}

if ( is_admin() )
{
	add_action( 'admin_print_styles', 'watcheezy_admin_menu_styles' );
	add_action('admin_menu', 'watcheezy_admin_menu');
	
	function watcheezy_admin_menu() 
	{
		$menu_Config= 'Settings';
		$lang_popup='us';
		
		add_menu_page(
		'Watcheezy', //$page_title
		'Watcheezy', //$menu_title
		'administrator', //$capability
		'watcheezy', //$menu_slug
		'watcheezy_settings_page', //$function
		'', //$icon_url
		55//$position
		);
		/*add_submenu_page(
				'state', //$parent_slug,
				$menu_Config, //$page_title,
				$menu_Config, //$menu_title,
				'administrator', //$capability,
				'watcheezy&#38;action=lister-config', //$menu_slug,
				'watcheezy_html_page' //$function = ''
				
		);*/
	}
}

function watcheezy_settings_page()
{
	global $wee_domain; 
	//Check if the website has already an old registration
	
	//preg_match("/^(http:\/\/)?([^\/]+)/i",get_option('siteurl'),$chaines);
	$res1="null";
	$hosturl = get_site_url();
	$res1 = getRemote('https://www.watcheezy.net/public/get_remote_licence.php?cms=WP&url='.$hosturl);
	
	if($res1!="null")
		update_option('weeID', $res1);
	
	if(get_option('weeID'))
	{ ?>
		<div style="height:200px">&nbsp;</div>
		<div class="update-nag"><h2>Great! Your licence is now activated<br>To connect to Wacheezy backoffice please check your email</h2></div>
		<?php 
	} 
	if(get_option('weeError'))
	{ ?>
		<div style="height:200px">&nbsp;</div>
		<div class="update-nag"><h2>Error:<?php echo get_option('weeError'); ?><br> Please <a href="http://www.watcheezy.com/en/contact.html">Contact us</a></h2></div>
		<?php 
	}
	if(!get_option('weeID'))
	{ ?>
		<div class="wrap">
		<?php screen_icon() ?>
		<h2><?php _e('Watcheezy Wordpress Plugin', $wee_domain) ?></h2>
		<form method="post" action="<?php echo admin_url('admin.php?page=watcheezy') ?>">
		<?php wp_nonce_field('update-options') ?>
		<p><?php _e('To finish the installation process, please fill and submit this form.', $wee_domain) ?></p>
		<p><label for="weeID"><?php _e('Site URL', $wee_domain) ?></label><br />
		<input size="40" type="text" name="weeUrl" id="weeFN" value="<?php 
				preg_match("/^(http:\/\/)?([^\/]+)/i",get_option('siteurl'),$chaines);
				$host = "http://".$chaines[2];
		echo get_site_url(); ?>" required />
				<p><label for="weeID"><?php _e('Enter your First Name', $wee_domain) ?></label><br />
				<input type="text" name="weeFN" id="weeFN" value="<?php echo(get_option('weeFN')) ?>" required />
								<p><label for="weeID"><?php _e('Enter your Last Name', $wee_domain) ?></label><br />
				<input type="text" name="weeLN" id="weeLN" value="<?php echo(get_option('weeLN')) ?>" required/>
								<p><label for="weeID"><?php _e('Enter your Mail Adress', $wee_domain) ?></label><br />
				<input type="email" name="weeEmail" id="weeEmail" value="<?php echo get_option('weeEMail') ? get_option('weeEmail') : get_option('admin_email'); ?>" required />
								<p><label for="weeID"><?php _e('Enter a Password', $wee_domain) ?></label><br />
				<input type="password" name="weePwd" id="weeLN" value="<?php echo(get_option('weePwd')) ?>" required />
				</p><p class="submit" style="padding:0">
				<input type="hidden" name="action" value="update" />
				<input type="hidden" name="page_options" value="weeID" />
				<input type="submit" name="weeSubmit" id="idzSubmit" value="<?php _e('Activate your licence', $wee_domain) ?>" class="button-primary" /> 
				</p>
			</form>
		</div>
<?php 
	}
}
?>